//+------------------------------------------------------------------+
//|                                              Ishimoku - MACD.mq4 |
//|                                                               TO |
//|                         http://www.forex-tradexperts-to.narod.ru |
//+------------------------------------------------------------------+
#property copyright "TO"
#property link      "http://www.forex-tradexperts-to.narod.ru"
#include <WinUser32.mqh>

extern string =" Ichimoku";
extern int tenkan_sen=12;
extern int kijun_sen=72;
extern int senkou_span_b=288;
extern string a=" Moving Average";
extern int MaPeriod=5;
extern int ma_method=1;
extern int applied_price=3; 
extern string a=" MACD";
extern int FastEMA=5;
extern int SlowEMA=34;
extern int SignalEMA=5;
extern string ap=" ";
extern int TP=300;
extern int SL=500;
extern int slippage=3;
extern double lot=0.1;
extern bool 1/*(TENKANSEN . KIJUNSEN)*/ =true;
extern bool 2/*(TENKANSEN . Ma)*/=true;
extern bool trailing=true;
extern double trailingStop=100;
extern int zashita=1;

bool buy1=false,buy2=false,buy3=false,buy4=false;
bool sell1=false,sell2=false,sell3=false,sell4=false,sell22=false,buy22=false;
int ticket=0;
int i;
datetime t1=0,t2=1,t3=1,t4=1,t5=1,t7=1,t8=1;
int init()
{
   return(0);
}
int deinit()
{
   return(0);
}

int start()
  {
      t1=Time[0];

      double MACDRED1=iMACD(NULL,0,FastEMA,SlowEMA,SignalEMA,PRICE_CLOSE,MODE_MAIN,1);
      double MACDRED2=iMACD(NULL,0,FastEMA,SlowEMA,SignalEMA,PRICE_CLOSE,MODE_MAIN,2);
      double MACDBLUE1=iMACD(NULL,0,FastEMA,SlowEMA,SignalEMA,PRICE_CLOSE,MODE_SIGNAL,1);
      double MACDBLUE2=iMACD(NULL,0,FastEMA,SlowEMA,SignalEMA,PRICE_CLOSE,MODE_SIGNAL,2);
      
      double IshRed1=iIchimoku(NULL,0,tenkan_sen,kijun_sen,senkou_span_b,MODE_TENKANSEN,1);
      double IshRed2=iIchimoku(NULL,0,tenkan_sen,kijun_sen,senkou_span_b,MODE_TENKANSEN,2);
      double IshBlue1=iIchimoku(NULL,0,tenkan_sen,kijun_sen,senkou_span_b,MODE_KIJUNSEN,1);
      double IshBlue2=iIchimoku(NULL,0,tenkan_sen,kijun_sen,senkou_span_b,MODE_KIJUNSEN,2);
      
      double MA1=iMA(NULL,0,MaPeriod,0,ma_method,applied_price,1);
      double MA2=iMA(NULL,0,MaPeriod,0,ma_method,applied_price,2);
      
      if(MACDRED1>MACDBLUE1 && MACDRED2<MACDBLUE2 && t3!=t1)
      {  //   MACD BUY
         buy1=true;sell1=false;t3=Time[0];
      }
      
      if(MACDRED1<MACDBLUE1 && MACDRED2>MACDBLUE2 && t3!=t1)
      {  //   MACD SELL
         sell1=true;buy1=false;t3=Time[0];
      }
   
      if(IshRed1>MA1 && IshRed2<=MA2 && t4!=t1)
      {  //        BUY
         buy2=true;sell2=false;t4=Time[0];
      }  
      
      if(IshRed1<MA1 && IshRed2>=MA2 && t4!=t1)
      {  //        SELL
         sell2=true;buy2=false;t4=Time[0];
      }
      
      if(IshRed1>IshBlue1 && IshRed2<IshBlue2 && t5!=t1) 
      {  //        BUY
         buy3=true;sell3=false;t5=Time[0];
      }
      
      if(IshRed1<IshBlue1 && IshRed2>IshBlue2 && t5!=t1) 
      {  //        SELL
         sell3=true;buy3=false;t5=Time[0];
      }
      
      if(1==true && buy3==true && buy4==true && t1!=t8)
      {  // 
         PlaySound("Alert.wav");
         int ret=MessageBox("   Buy?","",MB_YESNO|MB_ICONQUESTION);
         if(ret==6){ticket=OrderSend(Symbol(),OP_BUY,lot,Ask,slippage,Bid-SL*Point,Ask+TP*Point,NULL,0,0,Blue);if(ticket>0)PlaySound("ok.wav");if(ticket<0)Alert("  !!!  - "+GetLastError()+" ");}
         t8=Time[0];buy3=false;buy4=false;
      }
      
      if(1==true && sell3==true && sell4==true && t1!=t7)
      {  //  
         PlaySound("Alert.wav");
         int ret2=MessageBox("   Sell?","",MB_YESNO|MB_ICONQUESTION);
         if(ret2==6){ticket=OrderSend(Symbol(),OP_SELL,lot,Bid,slippage,Ask-SL*Point,Bid+TP*Point,NULL,0,0,Red);if(ticket>0)PlaySound("ok.wav");if(ticket<0)Alert("  !!!  - "+GetLastError()+" ");}
         t7=Time[0];sell3=false;sell4=false;
      }
      
      for(i=OrdersTotal()-1;i>=0;i--)
      {
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderType()==OP_BUY)
         {
            buy1=false;buy2=false;buy22=true;
            break;
         }
      }
      
      if(2==true && buy22 && IshRed1>MA1 && IshRed2<=MA2 && t4!=t1)
      { //     _  Buy
         PlaySound("Alert.wav");
         int ret3=MessageBox("   Buy?","",MB_YESNO|MB_ICONQUESTION);
         if(ret3==6){ticket=OrderSend(Symbol(),OP_BUY,lot,Ask,slippage,Bid-SL*Point,Ask+TP*Point,NULL,0,0,Blue);if(ticket>0)PlaySound("ok.wav");if(ticket<0)Alert("  !!!  - "+GetLastError()+" ");}
         t4=Time[0];buy22=false;
      }
      
      if(2==true && sell22 && IshRed1<MA1 && IshRed2>=MA2 && t4!=t1)
      { //     _  Sell
         PlaySound("Alert.wav");
         int ret4=MessageBox("   Sell?","",MB_YESNO|MB_ICONQUESTION);
         if(ret4==6){ticket=OrderSend(Symbol(),OP_SELL,lot,Bid,slippage,Ask-SL*Point,Bid+TP*Point,NULL,0,0,Red);if(ticket>0)PlaySound("ok.wav");if(ticket<0)Alert("  !!!  - "+GetLastError()+" ");}
         t4=Time[0];sell22=false;
      }
            
      if(buy1==true && buy2==true && t1!=t2)
      {  //  
         for(i=OrdersTotal()-1;i>=0;i--)
         {
            OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
            if(OrderType()==OP_SELL)OrderClose(OrderTicket(),OrderLots(),Ask,slippage,Gold);           
         } 
         PlaySound("Alert.wav");
         ticket=OrderSend(Symbol(),OP_BUY,lot,Ask,slippage,Bid-SL*Point,Ask+TP*Point,NULL,0,0,Blue);
         if(ticket>0)PlaySound("ok.wav");
         if(ticket<0)Alert("  !!!  - "+GetLastError()+" ");
         t2=Time[0];buy1=false;buy2=false;buy4=true;
      }
      
      for(i=OrdersTotal()-1;i>=0;i--)
      {
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderType()==OP_SELL)
         {
            sell1=false;sell2=false;sell22=true;
            break;
         }
      }
      if(sell1==true && sell2==true && t1!=t2)
      {  //  
         for(i=OrdersTotal()-1;i>=0;i--)
         {
            OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
            if(OrderType()==OP_BUY)OrderClose(OrderTicket(),OrderLots(),Bid,slippage,Gold);           
         }
         PlaySound("Alert.wav");          
         ticket=OrderSend(Symbol(),OP_SELL,lot,Bid,slippage,Ask+SL*Point,Bid-TP*Point,NULL,0,0,Red);
         if(ticket>0)PlaySound("ok.wav");
         if(ticket<0)Alert("  !!!  - "+GetLastError()+" ");
         t2=Time[0];sell1=false;sell2=false;sell4=true;buy22=false;
         
      }
      //Trailing stop
      double SL,TP,openprice,profit;
      int ticketOrder,zamok,type;
      string comm;
     
      for(i=OrdersTotal();i>=0;i--)
      {
         OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         
         if(trailing==true && OrderProfit()/MarketInfo(Symbol(),MODE_TICKVALUE)>0 && MathFloor(OrderProfit()/MarketInfo(Symbol(),MODE_TICKVALUE)/trailingStop)!=0 && (OrderProfit()/MarketInfo(Symbol(),MODE_TICKVALUE))>=trailingStop*MathFloor(OrderProfit()/MarketInfo(Symbol(),MODE_TICKVALUE)/trailingStop))
         {
               
               if(OrderType()==0){SL=Bid-trailingStop*Point;if(SL==OrderOpenPrice())SL+=zashita*Point;}
               if(OrderType()==1){SL=Ask+trailingStop*Point;if(SL==OrderOpenPrice())SL-=zashita*Point;}
               TP=OrderTakeProfit();
               if(OrderType()==0)if(SL>=OrderStopLoss()+trailingStop*Point)OrderModify(OrderTicket(),OrderOpenPrice(),SL,TP,0);
               if(OrderType()==1)if(SL<=OrderStopLoss()-trailingStop*Point)OrderModify(OrderTicket(),OrderOpenPrice(),SL,TP,0);
         }
      }
   return(0);
  }

